/*
 *  Copyright 2015 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.linkdirectory');

/**
 * Enable or disable link reordering buttons depending on the link position.
 */
org.ametys.linkdirectory.MoveLinkButton = function(id, configuration, pluginName)
{
	org.ametys.linkdirectory.MoveLinkButton.superclass.constructor.call(this, id, configuration, pluginName);
}

Ext.extend(org.ametys.linkdirectory.MoveLinkButton, org.ametys.ribbon.control.button.ActionSelectionButton, {});

org.ametys.linkdirectory.MoveLinkButton.prototype.onMessage = function(messages)
{
    for (var i = messages.length-1; i >= 0; i--)
    {
        if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED)
        {
            var allTargets = messages[i].getTargets();
            var targets = org.ametys.messagebus.message.MessageTargetHelper.findAll(allTargets, this._testTarget.createDelegate(this));
            
            if (targets.length == 1 && this._testLink(targets[0]))
            {
                this.getElements().each(function(element) { element.enable(); });
            }
            else
            {
                this.getElements().each(function(element) { element.disable(); });
            }
        }
    }
}

/**
 * Test a link on a button.
 * @return {org.ametys.messagebus.message.MessageTarget} The target to check
 * @private
 */
org.ametys.linkdirectory.MoveLinkButton.prototype._testLink = function(target)
{
	var role = this.getConfiguration().role,
        index = target.getParameters().index,
        size= target.getParameters().size;
        
    return (((role == 'move-up' || role == 'move-first') && index != 0) || ((role == 'move-down' || role == 'move-last') && index != size - 1)) ? true : false;
}
